#!/bin/sh

echo "____   ____                    __________.__                    _____             .___"
echo "\   \ /   /________________    \______   \  |  __ __  ______   /     \   ____   __| _/"
echo " \   Y   // __ \_  __ \__  \    |     ___/  | |  |  \/  ___/  /  \ /  \ /  _ \ / __ |"
echo "  \     /\  ___/|  | \// __ \_  |    |   |  |_|  |  /\___ \  /    Y    (  <_> ) /_/ |"
echo "   \___/  \___  >__|  (____  /  |____|   |____/____//____  > \____|__  /\____/\____ |"
echo "              \/           \/                            \/          \/            \/"
echo ""
echo "Firmware patch for Vera Plus 7.0.29 by Rafale77"
while true; do
    read -p "Do you wish to take your vera offline?, If no packages will be upgraded.  " yn
    case $yn in
        [Yy]* ) cp -f binb/*.* /usr/bin/
                cp -f ini/*.* /etc/init.d/; break;;
        [Nn]* ) cp -f binb/lighttpd_ssl.sh /etc/init.d
                cp -f binb/set_led.sh /etc/init.d
                cp -f binb/sync_time.sh /etc/init.d; break;;
        * ) echo "Please answer yes, no or press Ctrl + c to exit";;
    esac
done
cp -f functions.sh /lib/;
cp -f profile /etc/
cp -f zwaveb/*.* /etc/zwave/
cp -f banner /etc/
cp -f opkg.conf /etc/
opkg update
opkg upgrade busybox nano
opkg upgrade lighttpd lighttpd-mod-cgi  lighttpd-mod-auth lighttpd-mod-proxy  lighttpd-mod-accesslog
opkg remove luci luci-lib* luci*
opkg remove lighttpd-mod-usertrack lighttpd-mod-status lighttpd-mod-fastcgi lighttpd-mod-rewrite lighttpd-mod-redirect lighttpd-mod-access lighttpd-mod-status lighttpd-mod-compress
echo "essential upgrades complete"
while true; do
    read -p "Do you wish to upgrade libraries (makes sure that your vera is extrooted).  " yn
    case $yn in
        [Yy]* ) echo "ok upgrading libraries..."; break;;
        [Nn]* ) mv -f opkg2.conf /etc/opkg.conf
                opkg update
                cd ..
                rm -R VeraMods*; exit;;
        * ) echo "Please answer yes, no or press Ctrl + c to exit";;
    esac
done
echo "ok! upgrading libraries and binaries"
opkg upgrade libubox ubus ubox libubus libubus-lua libubox-lua ubusd uci libuci-lua libuci
opkg upgrade libopenssl libpolarssl openssl-util
opkg upgrade e2fsprogs tune2fs libffi losetup sfdisk block-mount libext2fs fstools libblkid libuuid
opkg upgrade libusb-1.0 usb-modeswitch
opkg upgrade luaposix luaexpat luasocket libpopt getopt ser2net luasoap
opkg upgrade libxml2 libmagic libpcre libexif  glib2 libjpeg jshn libreadline libblobmsg-json
opkg upgrade haserl libncursesw libnl-tiny px5g jshn libattr
opkg upgrade mtr mtd patch file curl libcurl libncurses
opkg upgrade ntpclient terminfo diffutils chat zwaveserial
opkg upgrade libjson-c libintl-full libblobmsg-json librpc libmnl libnetfilter-conntrack ddns-scripts flock
opkg install libjson
opkg upgrade ip dnsmasq dropbear dropbearconvert iw libiwinfo iwinfo
mv -f opkg2.conf /etc/opkg.conf
opkg update
opkg upgrade hostapd hostapd-utils libjson-script base-files netifd firewall
opkg install --force-overwrite *.ipk
rm /usr/lib/libreadline.so.5
ln -s libreadline.so.6.3 /usr/lib/libreadline.so.5
ln -s libjpeg.so.9 /usr/lib/libjpeg.so.62
ln -s libpcre.so.1 /usr/lib/libpcre.so.0
cd ..
/etc/init.d/sysntpd disable
rm -R VeraMods
cd VeraMods2
./modvera2.sh
# opkg upgrade procd opkg
# opkg upgrade luci-base luci-lib-luaneightbl luci-lib-px5g luci-lib-json luci-lib-nixio luci-lib-httpclient
